﻿# Define your animations here
image Marry Idle:
    Crop((32, 0, 32, 32), "press dance/Marry.png")
image Marry Down:
    Crop((0, 0, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 0, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((64, 0, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 0, 32, 32), "press dance/Marry.png")
    pause .2
    repeat
image Marry Left:
    Crop((0, 32, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 32, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((64, 32, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 32, 32, 32), "press dance/Marry.png")
    pause .2
    repeat
image Marry Right:
    Crop((0, 64, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 64, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((64, 64, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 64, 32, 32), "press dance/Marry.png")
    pause .2
    repeat
image Marry Up:
    Crop((0, 96, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 96, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((64, 96, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 96, 32, 32), "press dance/Marry.png")
    pause .2
    repeat
image Marry Mistake:
    Crop((32, 0, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 32, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 64, 32, 32), "press dance/Marry.png")
    pause .2
    Crop((32, 96, 32, 32), "press dance/Marry.png")
    pause .2
    repeat
init python:
    class press:
        def __init__(self, name, key, rot, x, y):
            self.name = name
            self.key = key
            self.left = 0
            self.rot = rot
            self.x = x
            self.y = y
        def pressed(self, g):
            if self.left:
                g.points += self.left
                msg3("+"+str(self.left))
                self.left = 0
                g.change(self.name)
            else:
                g.points -= 200
                msg4("-200")
                g.change("Mistake")
        def start(self, amount):
            self.left = amount
    class press_dance_handler:
        def __init__(self, name, parts = []):
            self.name = name
            self.parts = parts
            self.dancer = "Marry"
            self.move = "Idle"
            self.points = 0
            self.duration = 0
            self.floor = 1

        def tick(self):
            for i in self.parts:
                if i.left > 0:
                    i.left -= 2
                    if i.left < 1:
                        i.left = 0
                        self.points -= 500
                        msg4("-500")
                        self.change("Mistake")
        def rand(self):
            r = renpy.random.choice(self.parts)
            if not r.left:
                r.left = renpy.random.randint(60, 260)
        def change(self, move):
            self.move = move
            if move == "Mistake":
                renpy.play("press dance/fail.ogg", "sound")
                self.floor = "red"
            else:
                renpy.play("press dance/success.ogg", "sound")
                self.floor = "green"
        def ground(self):
            r = renpy.random.randint(1,9)
            if not r == self.floor:
                self.floor = r
            else:
                self.ground()
        def start(self, duration):
            self.move = "Idle"
            self.points = 0
            self.duration = duration
        def timer(self):
            self.duration -= 1


default press_left = press(
    "Left",
    "a",
    0,
    -300, 0
)
default press_right = press(
    "Right",
    "d",
    180,
    300, 0
)
default press_up = press(
    "Up",
    "w",
    90,
    0, -300
)
default press_down = press(
    "Down",
    "s",
    -90,
    0, 300
)

default press_dance_1 = press_dance_handler(
    "Example",
    [
        press_left,
        press_right,
        press_up,
        press_down,
    ]
)

screen press_dance(g = press_dance_1, target = 1000, duration = 30):
    modal True
    on "show" action Function(g.start, duration)
    add "#444" # delete or change this line if you have a background
    frame:
        align .5,.5 offset 160,-126 background None anchor 0.0,.5
        vbox:
            text _("Points: ") + str(g.points) size 24
            text _("Time: ") + str(g.duration) size 24
    add "press dance/{}.png".format(g.floor) align .5,.5
    add "{} {}".format(g.dancer, g.move) align .5,.5 at press_zoom(4)
    for i in g.parts:
        button:
            at press_rot(i.rot)
            align .5,.5 xoffset i.x yoffset i.y
            action Function(i.pressed, g) keysym i.key
            fixed:
                fit_first True
                add "press dance/rail.png"
                if i.left:
                    vbox:
                        align .1,.5
                        add "press dance/arrow.png" xoffset i.left align .5,.5
        # key i.key action Function(i.pressed, g)

    hbox: # remove these if you want to force the player to finish the game
        style_prefix "dancedialogue"
        align 0.0,1.0 spacing 10 offset 10, -10
        button:
            text "Restart"
            action Function(g.start, duration)
        button:
            text "Skip"
            action Return(g.points), Hide("press_dance")

    if g.duration < 1: # if the time is up
        if g.points < target: # check if the target points is reached: win
            frame:
                style_prefix "dancedialogue"
                vbox:
                    text "Time is up. you've only got {} of {} points required.".format(g.points, target)
                    hbox:
                        align .5,.5 spacing 10
                        button:
                            text "Retry"
                            action Function(g.start, duration)
                        button:
                            text "Exit"
                            action Return(g.points), Hide("press_dance")
        else: # otherwise: lose
            frame:
                style_prefix "dancedialogue"
                vbox:
                    text "Great work, you've got {} that's enough to win.".format(g.points)
                    hbox:
                        align .5,.5 spacing 10
                        button:
                            text "Again"
                            action Function(g.start, duration)
                        button:
                            text "Done"
                            action Return(g.points), Hide("press_dance")
    else:
        timer .01 repeat True action Function(g.tick)
        timer 2 repeat True action Function(g.rand)
        timer .5 repeat True action Function(g.ground)
        timer 1 repeat True action Function(g.timer)

style dancedialogue_frame:
    align (.5,.5)
    background "#000b"
    padding (40,40)
style dancedialogue_button:
    align (.5,.5)
    background "#002b"
    padding (10,10)
style dancedialogue_vbox:
    spacing 20

transform press_rot(r):
    rotate_pad False
    rotate r

transform press_zoom(z):
    zoom z

label press_dance_example:
    play music "press dance/music.ogg" 
    call screen press_dance(target = 1000, duration = 32)
    stop music
    "You've got [_return] points."
    return